#ifdef UNIX
  static char rcsid[] = "$Id: spotcore.c,v 1.1 1993/01/06 22:01:21 andrew Exp $";
#endif

/* (spotcore.c)
 *
 * Hang around looking periodically for core files in the current dir.
 * If one is found, pop up a box telling the user.
 *
 *
 * 1992 Andrew Cosgriff
 *
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/panel.h>

typedef struct _core_rec
{
  char name[80];
  char lastmod[80];
} Core_Rec;

Frame          frame;
Panel          panel;
Core_Rec       files[10];
int            num_files;
int            count;

void ok();
void remove_win();
void quit();

main(argc, argv)
int          argc;
char        *argv[];
{
  FILE          *testfile;
  struct stat    statbuf;
  char           line1[80];
  char           line2[80];


  (void) xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL);

  num_files = 0;
  while ((num_files < 10) && (num_files < (argc -1)))
  {
    if (strlen(argv[num_files+1]) > 0)
    {
      strcpy(files[num_files].name,argv[num_files +1]);
      files[num_files].lastmod[0] = '\0';
      printf("Spotting %s\n",files[num_files].name);
      num_files++;
    }
  }
  if (num_files == 0)
  {
    num_files = 1;
    sprintf(files[0].name,"core");
    printf("Spotting ./core\n");
  }


  for (;;) /* Forever */
  {
    for (count = 0; count < num_files; count++)
    {
      if ((testfile = fopen(files[count].name,"r")) != NULL)
      {
	fclose(testfile);
	
	stat(files[count].name,&statbuf);

	if (strcmp(ctime(&(statbuf.st_mtime)), files[count].lastmod) != 0)
        {
	  strcpy(files[count].lastmod,ctime(&(statbuf.st_mtime)));

	  sprintf(line1,"Size is %d Bytes",statbuf.st_size);
	  sprintf(line2,"Created on %s",ctime(&(statbuf.st_mtime)));
	  
	  frame = (Frame) xv_create(NULL, FRAME,
				    FRAME_LABEL, "File Spotted !",
				    FRAME_SHOW_RESIZE_CORNER, FALSE,
				    NULL);
	  
	  panel = (Panel) xv_create(frame, PANEL,
				    NULL);

	  (void) xv_create(panel, PANEL_MESSAGE,
			   PANEL_NEXT_ROW, -1,
			   PANEL_LABEL_STRING, files[count].name,
			   NULL);
	
	  (void) xv_create(panel, PANEL_MESSAGE,
			   PANEL_NEXT_ROW, -1,
			   PANEL_LABEL_STRING, line1,
			   NULL);
	  
	  (void) xv_create(panel, PANEL_MESSAGE,
			   PANEL_NEXT_ROW, -1,
			   PANEL_LABEL_STRING, line2,
			   NULL);
	  
	  (void) xv_create(panel, PANEL_BUTTON,
			   PANEL_NEXT_ROW, -1,
			   PANEL_LABEL_STRING, "Ok",
			   PANEL_NOTIFY_PROC, ok,
			   NULL);
	  
	  (void) xv_create(panel, PANEL_BUTTON,
			   PANEL_LABEL_STRING, "Remove",
			   PANEL_NOTIFY_PROC, remove_win,
			   NULL);
	  
	  (void) xv_create(panel, PANEL_BUTTON,
			   PANEL_LABEL_STRING, "Quit",
			   PANEL_NOTIFY_PROC, quit,
			   NULL);
	  
	  window_fit(panel);
	  window_fit(frame);
	  
	  xv_set(frame,
		 XV_X, (1159 / 2) - ((int)xv_get(frame, XV_WIDTH) / 2),
		 XV_Y, (900  / 2) - ((int)xv_get(frame, XV_HEIGHT) / 2),
		 NULL);
	  
	  xv_main_loop(frame);
	}
      }
    }
    sleep(5);
  }
}


void ok()
{
  xv_destroy_safe(frame);
}


void remove_win()
{
  unlink(files[count].name);
  files[count].lastmod[0] = '\0';
  ok();
}


void quit()
{
  ok();
  exit(0);
}
